// Uebung3 Betriebssysteme 2
// Matthias Jauernig, 2006
// Empfaenger-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/msg.h>
#include <sys/stat.h>
#include <stropts.h>

#define PIPENAME "pipe"
#define INITSEND 0
#define SENDDATA 1
#define ENDSEND  2

struct mymsg{
	long pid;
	char mtext[100];
};

int main(void){
	int rc, scount, fd, flags;
	FILE *fp, *fp1;
	struct stat buf;
	struct strbuf ctl, data;
	struct mymsg *msg = (struct mymsg*)malloc(sizeof(struct mymsg));
	char* cbuf = (char*)malloc(1);   // Puffer fr Steuerinformationen
	char* fname = (char*)malloc(100*sizeof(char));
	
	// Pipe-Test
	mode_t mode;
	mode = 0644;
	if((rc=stat(PIPENAME, &buf)) < 0){
		if(errno != ENOENT){
			perror("stat");
			return 1;
		}
		if((rc=mkfifo(PIPENAME, mode)) < 0){
			perror("mkfifo");
			return 2;
		}
	}
	else{
		if(!S_ISFIFO(buf.st_mode)){
			printf("File %s existiert, ist aber keine Pipe.\n", PIPENAME);
			return 3;
		}
	}
	
	// vorhandene Pipe zum Lesen oeffnen
	if((fp = fopen(PIPENAME, "r")) < 0){
		perror("fopen");
		return 4;
	}
	fd = fileno(fp);
	
	scount = 0;		// Anzahl angemeldeter Sender
	flags = 0;		// normale Prioritt von Nachrichten
  	ctl.maxlen = 1;		// Kontrollbereich = 1 Byte
 	ctl.buf = cbuf;		// Kontrollpuffer
  	data.maxlen = sizeof(struct mymsg);	// max. Lnge = Gre der struct
	data.buf = (char*)msg;	// Datenbereich

	// Nachrichten aus Pipe lesen bis keine Sender mehr vorhanden
	do{
		if((rc=getmsg(fd, &ctl, &data, &flags)) < 0){
			perror("getmsg");
		}
		sprintf(fname, "%ld.txt", msg->pid);
		switch(cbuf[0]){
		case INITSEND: // Initial-Sendung
			scount++;
			printf("Sender %ld hat sich angemeldet, %d Sender nun vorhanden.\n", msg->pid, scount);
			break;
		case SENDDATA: // neue Nachricht gesendet
			printf("Neue Nachricht von Sender %ld empfangen.\n", msg->pid);
			fp1 = fopen(fname, "a"); // Datei zum Anhaengen oeffnen oder neu erstellen
			fwrite(&msg->mtext, sizeof(msg->mtext), 1, fp1); // Nachrichtenzeile an Datei anhaengen
			fclose(fp1);
			break;
		case ENDSEND: // Sender-Ende
			scount--;
			if((fp1 = fopen(fname, "r")) != NULL){	// Datei oeffnen, um Inhalt zu lesen
				printf("Sender %ld hat sich beendet, noch %d Sender vorhanden.\n", msg->pid, scount);
				printf("Text von Sender %ld:\n", msg->pid);
				while(fread(msg->mtext, sizeof(msg->mtext), 1, fp1) > 0){
					printf("%s", msg->mtext);
				}
				fclose(fp1);
				unlink(fname);
			}
			break;
		}
	}while(scount > 0);
	
	fclose(fp);		// Pipe schlieen
	unlink(PIPENAME);	// Pipe entfernen
	
	return 0;
}
